%define anolis_release 1
Name:           jemalloc
Version:        5.3.0

Release:        %{anolis_release}%{?dist}
Summary:        General-purpose scalable concurrent malloc implementation

License:        BSD
URL:            http://www.canonware.com/jemalloc/
Source0:        https://github.com/jemalloc/%{name}/releases/download/%{version}/%{name}-%{version}.tar.bz2

BuildRequires:  gcc
BuildRequires:  /usr/bin/xsltproc
BuildRequires:  perl-generators
BuildRequires:  valgrind-devel
BuildRequires:  make

%description
General-purpose scalable concurrent malloc(3) implementation.
This distribution is the stand-alone "portable" implementation of %{name}.

%package devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package doc
Summary:         Doc files for %{name}
Requires:        %{name} = %{version}-%{release}
BuildArch:       noarch

%description doc
Doc files for %{name}.

%prep
%setup -q

%ifarch x86_64 aarch64
%define lg_page --with-lg-page=12
%endif

# Disable thp on systems not supporting this for now
%ifarch aarch64
%define disable_thp --disable-thp
%endif


%build
echo "For debugging package builders"
echo "What is the pagesize?"
getconf PAGESIZE

echo "What mm features are available?"
ls /sys/kernel/mm
ls /sys/kernel/mm/transparent_hugepage || true
cat /sys/kernel/mm/transparent_hugepage/enabled || true

echo "What kernel version and config is this?"
uname -a

%configure %{?disable_thp} %{?lg_page}
%make_build


%check
# we set PAGESIZE to 4K because kernel PAGESIZE is 4K both on aarch64 and x86_64
# while check on 64K PAGESIZE host, will get error: "<jemalloc>: Unsupported system page size"
# make check just when PAGESIZE is 4K in running kernel
pagesize=`getconf PAGESIZE`
if [ "$pagesize" == "4096" ]; then
	make %{?_smp_mflags} check
fi


%install
%make_install DESTDIR=%{buildroot}
# Install this with doc macro instead
rm %{buildroot}%{_datadir}/doc/%{name}/jemalloc.html

find %{buildroot}%{_libdir}/ -name '*.a' -exec rm -vf {} ';'

%generate_compatibility_deps

%files
%dir %{abidir}
%{_libdir}/libjemalloc.so.*
%{_bindir}/jemalloc.sh
%license COPYING
%{abidir}/libjemalloc.dump
%{abidir}/*-option.list

%files devel
%{_includedir}/jemalloc
%{_bindir}/jemalloc-config
%{_libdir}/pkgconfig/jemalloc.pc
%{_bindir}/jeprof
%{_libdir}/libjemalloc.so
%{_mandir}/man3/jemalloc.3*

%files doc
%doc README VERSION
%doc doc/jemalloc.html

%changelog
* Thu Jan 12 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 5.3.0-1
- init from upstream
